import sys, os
sys.path.insert(0, os.path.abspath(os.path.join(os.path.dirname(__file__), '..')))
from os import walk
import zetane.context as ztn
from PIL import Image
import numpy as np
import onnxruntime as rt
import pathlib


# Preprocess image
def preprocess(image, i):
    x = np.array(image).astype('float32')
    scene.image(data=x/255.0).position(x=-10.0, y=(2.5 * i)).scale(0.05, 0.05).update()
    x = np.transpose(x, [2, 0, 1])
    x = np.expand_dims(x, axis=0)
    return x

def onnx(image, i):
    session = rt.InferenceSession("mosaic.onnx")
    output_name = session.get_outputs()[0].name
    input_name = session.get_inputs()[0].name
    result = session.run([output_name], {input_name: x})[0][0] 
    scene.image(data=result).position(x=15.0, y=2.5 * i).scale(0.05, 0.05)

# loading input and resize if needed
images = []
for p in pathlib.Path('pics').iterdir():
    if p.is_file():
        images.append(Image.open(p).convert('RGB'))

images = list(map(lambda image: image.resize((224, 224), Image.NEAREST), images))

scene = ztn.Context(remote=True)
mosaic = scene.model()

for i,image in enumerate(images):
    x = preprocess(image, i)
    mosaic.onnx("mosaic.onnx").inputs(x).update()
    scene.snapshot()



